/* Movies Errors.h
	Error Codes

	by Jim Batson, Bruce Leak, David Van Brink, Peter Hoddie
	Copyright 1990 Apple Computer, Inc. All rights reserved.
*/

#ifndef _MoviesErrors_
#define _MoviesErrors_


typedef enum {
	firstMoviesError = -2000,

	couldNotResolveDataRef = -2000,
	badImageDescription = -2001,
	badPublicMovieAtom = -2002,
	cantFindHandler = -2003,
	cantOpenHandler = -2004,
	badComponentType = -2005,
	noMediaHandler = -2006,
	noDataHandler = -2007,
	invalidMedia = -2008,
	invalidTrack = -2009,
	invalidMovie = -2010,
	invalidSampleTable = -2011,
	invalidDataRef = -2012,
	invalidHandler = -2013,
	invalidDuration = -2014,
	invalidTime = -2015,
	cantPutPublicMovieAtom = -2016,
	badEditList = -2017,
	mediaTypesDontMatch = -2018,
	progressProcAborted = -2019,
	movieToolboxUninitialized = -2020,
	wffileNotFound = -2021,
	cantCreateSingleForkFile = -2022,			/* happens when file already exists */
	invalidEditState = -2023,
	nonMatchingEditState = -2024,
	staleEditState = -2025,
	userDataItemNotFound = -2026,
	maxSizeToGrowTooSmall = -2027,
	badTrackIndex = -2028,
	trackIDNotFound = -2029,
	trackNotInMovie = -2030,
	timeNotInTrack = -2031,
	timeNotInMedia = -2032,
	badEditIndex = -2033,
	internalQuickTimeError = -2034,
	cantEnableTrack = -2035,
	invalidRect = -2036,
	invalidSampleNum = -2037,
	invalidChunkNum = -2038,
	invalidSampleDescIndex = -2039,
	invalidChunkCache = -2040,
	invalidSampleDescription = -2041,
	
/* this should probably be in its own range for data handlers */
	dataNotOpenForRead = -2042,	
	dataNotOpenForWrite = -2043,	
	dataAlreadyOpenForWrite = -2044,
	dataAlreadyClosed = -2045,
	endOfDataReached = -2046,
	dataNoDataRef = -2047,

/* private errors */
	noMovieInDataFork = -2048,					/* this is a private error */
	
	invalidDataRefContainer = -2049,
	badDataRefIndex = -2050,
	invalidBlob = -2051,

	couldNotUseAnExistingSample = -2052,
	
	featureUnsupported = -2053,

	lastMoviesError,
	noRecordOfApp = movieToolboxUninitialized			/* replica */
	}moviesErrors;



#endif _MoviesErrors_


#ifndef _ComponentErrors_
#define _ComponentErrors_


typedef enum {
	firstComponentError = -3000,
	
	invalidComponentID = firstComponentError,
	validInstancesExist = -3001,
	componentNotCaptured = -3002,
	lastComponentError = -3003
	}componentError;

#endif _ComponentErrors_

