/*
	File:		StandardPreview.h
	Contains:	Headers for Previewing Extensions to Standard File Package
	Copyright:	 1990 by Apple Computer, Inc., all rights reserved.
*/

#ifndef __STANDARDPREVIEW__
#define __STANDARDPREVIEW__


#include <StandardFile.h>	/* because this code is based on Standard File */
#include <Files.h>			/* to get definition of FSSpec */

/************** Previewing Extensions to The Standard File Package **********/

#ifdef __cplusplus
extern "C" {
#endif

pascal void 
StandardGetFilePreview(		
		FileFilterProcPtr 	fileFilter,
		short 				numTypes,
		SFTypeList 			typeList,
		StandardFileReply *	reply)
		
    = {0x3F3C,0x0009,0xA9EA}; 
							
pascal void 
CustomGetFilePreview(	
		FileFilterYDProcPtr		fileFilter,
		short					numTypes,
		SFTypeList				typeList, 
		StandardFileReply *		reply, 
		short					dlgID,
		Point					where, 
		DlgHookYDProcPtr		dlgHook, 
		ModalFilterYDProcPtr	filterProc,
		short *					activeList, 
		ActivateYDProcPtr 		activateProc, 
		void *					yourDataPtr)	
		
		={ 0x3F3C, 0x000A, 0xA9EA };

#ifdef __cplusplus
}
#endif

/* Dialog box IDs for previewing */

enum {spGetDlgID_Sys6 = -3998};
enum {spGetDlgID_Sys7 = -6039};

/* Item numbers for the Previewing Dialog Boxes */

enum {spItemReserved =	 			10};
enum {spItemPreviewArea = 			11};
enum {spItemPreviewStatText = 		12};
enum {spItemVertDividerPict = 		13};
enum {spItemFileInfoField = 		14};
enum {spItemCreatePreviewButton = 	15};

enum {spFirstPreviewItemNumber = 	spItemPreviewArea};
enum {spLastPreviewItemNumber = 	spItemCreatePreviewButton};

#endif /* __STANDARDPREVIEW__ */