/**************************************************
*
* Definitions and equates for the Sample player
*
*  
***************************************************/

/* Movie definitions */
#include "Movies.h"
#include <Menus.h>
#include <Packages.h>
#include <AppleEvents.h>

#define x1Speed		(long)1<<16

/**************************************************
*
*  Definitions for the menus
*
***************************************************/

/* resource IDs of menus */
#define appleID		128
#define fileID		129
#define editID		130

/* Items in the Apple menu */
#define	aboutItem	1

/* Items in the edit menu */
#define	undoItem	1
#define	cutItem		3
#define	copyItem	4
#define	pasteItem	5
#define	clearItem	6
#define	selectAllItem	8

/* Items in the file menu */
#define openItem	1
#define closeItem	2
#define	saveItem	3
#define quitItem	5

/**************************************************
*
*  Definitions for dialog boxes
*
***************************************************/

/* other resources */
#define	aboutDlgID	132		/* About box */
#define	meowID		8192	/* Sound for about box */


/**************************************************
*
*  Record with data for each movie
*
***************************************************/
/* The maximum number of movies */
#define	maxMovies	20

typedef struct
	{
	Movie		movie;					/* The movie to play */
	WindowPtr	window;					/* Window the movie is played in */
	MovieController	movieController;	/* The controls for the movie */
	short		volume;
										/* This stuff was added for editing */
	short		resRefNum;
	short		resID;	
	short		idleCount;			
	} MovieInstance;
	

/**************************************************
*
*  Prototypes
*
***************************************************/
/* Routines in main.c */
void InitMacintosh(void);
void SetUpMenus(void);
void SetUpWindows(void);
void enable(MenuHandle menu, short item, Boolean ok);
void AdjustMenus(void);
void HandleMenu (long mSelect);
void CloseEm(WindowPtr w);
void CloseAllWindows(void);
void DoAboutBox(void);
void DoOpen(void);
MovieInstance* WhichMovieWindow(WindowPtr w);
Boolean IsMyWindow(WindowPtr w);
void HandleMouseDown(EventRecord *theEvent);
void HandleEvent(void);
void DoDoubleClick(void);
OSErr MissedAEParameters (AppleEvent *message);
pascal OSErr  OpenDocMessage(AppleEvent *message, AppleEvent *reply, long refcon);
pascal OSErr QuitAppMessage(AppleEvent *message, AppleEvent *reply, long refcon);

/* Routines in movie stuff */
void SetUpMovies(void);
MovieInstance* GetAvailMovie(void);
void CleanUpMovie(MovieInstance	*theMovie);
void SaveTheMovie(MovieInstance *theMovie);
void OpenTheMovie(FSSpec* file);
void MakeMovieControls(MovieInstance *theMovie);
void SetMovieWindowSize(MovieInstance *theMovie);
pascal Boolean MyPlayerFilter(MovieController pt, short *action, void *params);
void MovieMouseDown(WindowPtr theWindow, Point thePoint, short theModifiers);
void MyMoviesTask(void);
Boolean CheckMovieControllers(EventRecord *theEvent);
void DoMovieUpdate(MovieInstance *theMovie);
void DoMovieActivate(MovieInstance *theMovie);
void DoMovieDeactivate(MovieInstance *theMovie);
void DoMovieEdit(MovieInstance *theMovie, short menuItem);
