/**************************************************
*
* Definitions and equates for the Mini player
*
*  
***************************************************/

#include <Menus.h>
#include <Events.h>
#include <Controls.h>

/* The fixed number for times one speed */
#define x1Speed		(long)1<<16

/**************************************************
*
*  Definitions for the menus
*
***************************************************/

/* resource IDs of menus */
#define appleID		128
#define fileID		129
#define editID		130

/* Items in the Apple menu */
#define	aboutItem	1

/* Items in the file menu */
#define openItem	1
#define closeItem	2
#define	saveItem	3
#define quitItem	5


/**************************************************
*
*  Definitions for dialog boxes
*
***************************************************/

/* other resources */
#define	aboutDlgID	132		/* About box */
#define	meowID		8192	/* Sound for about box */


/**************************************************
*
*  Definitions for cursors
*
***************************************************/
#define	handCursorID	5004
#define	pauseCursorID	5000
#define	reverseCursorID	5001
#define	playCursorID	5002
#define	blinkCursorID	5003

/**************************************************
*
* Prototypes
*
***************************************************/
/* Files in mini main.c */
void InitMacintosh(void);
void SetUpMenus(void);
void SetUpWindows(void);
void SetUpCursors(void);
void AdjustMenus(void);
static enable(MenuHandle menu, short item, Boolean ok);
void CloseEm(WindowPtr w);
void DoAboutBox(void);
void DoOpen(void);
void AdjustCursor(void);
Boolean IsMyWindow(WindowPtr w);
void HandleMouseDown(EventRecord	*theEvent);
void HandleMouseUp(EventRecord	*theEvent);
void HandleEvent(void);
void main(void);
void HandleMenu (long mSelect);

/* Files in mini movie stuff.c */
void SetUpMovies(void);
void OpenTheMovie(Str255	fn, int	vRef);
void MakeMovieControls(void);
void MyMoviesTask(void);
void CleanUpMovie(void);
pascal void MovieScrollProc(ControlHandle theControl, int theCode);
void MovieMouseDown(WindowPtr theWindow, Point thePoint);
void MovieMouseUp(WindowPtr theWindow, Point thePoint);
void MovieCursor(void);
void DoMovieUpdate(void);


