/**************************************************
*
* Definitions and equates for the Sample player
*
*  
***************************************************/

/* Movie definitions */
#include "Movies.h"
#include "QuickTimeComponents.h"

#include <Menus.h>

#define x1Speed		(long)1<<16

/**************************************************
*
*  Definitions for the menus
*
***************************************************/

/* resource IDs of menus */
#define appleID		128
#define fileID		129
#define editID		130

/* Items in the Apple menu */
#define	aboutItem	1

/* Items in the file menu */
#define openItem	1
#define closeItem	2
#define	saveItem	3
#define quitItem	5

/**************************************************
*
*  Definitions for dialog boxes
*
***************************************************/

/* other resources */
#define	aboutDlgID	132		/* About box */
#define	meowID		8192	/* Sound for about box */


/**************************************************
*
*  Record with data for each movie
*
***************************************************/
/* The maximum number of movies */
#define	maxMovies	20

typedef struct
	{
	Movie		movie;				/* The movie to play */
	WindowPtr	window;				/* Window the movie is played in */
	MovieController	movieController;		/* The controls for the movie */
	short		volume;
	Boolean		loop;
	} MovieInstance;
	

/**************************************************
*
*  Prototypes
*
***************************************************/
/* Routines in main.c */
void InitMacintosh(void);
void SetUpMenus(void);
void SetUpWindows(void);
void enable(MenuHandle menu, int item, Boolean ok);
void AdjustMenus(void);
void HandleMenu (long mSelect);
void CloseEm(WindowPtr w);
void CloseAllWindows(void);
void DoAboutBox(void);
void DoOpen(void);
MovieInstance* WhichMovieWindow(WindowPtr w);
Boolean IsMyWindow(WindowPtr w);
void HandleMouseDown(EventRecord *theEvent);
void HandleEvent(void);

/* Routines in movie stuff */
void SetUpMovies(void);
MovieInstance* GetAvailMovie(void);
void CleanUpMovie(MovieInstance	*theMovie);
void OpenTheMovie(StandardFileReply* sfr);
void MakeMovieControls(MovieInstance *theMovie);
pascal Boolean MyPlayerFilter(MovieController pt, short *action, void *params);
void MovieMouseDown(WindowPtr theWindow, Point thePoint, int theModifiers);
void MyMoviesTask(void);
Boolean CheckMovieControllers(EventRecord *theEvent);
void DoMovieUpdate(MovieInstance *theMovie);
void DoMovieActivate(MovieInstance *theMovie);
void DoMovieDeactivate(MovieInstance *theMovie);
