/*
	File:		DIGIUtils.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1991 by Apple Computer, Inc., all rights reserved.

    This file is used in these builds: Warhol

	Change History (most recent first):

		 <6>	  5/2/91	CK		Add RectLocalToGlobal and RectGlobalToLocal
		 <5>	 4/17/91	CK		Remove CalculateScale, use new warhol header
		 <4>	 3/26/91	CK		Replace GlobalToVideoDigitizer with ValidatePixMap routine,
									remove the flipping routines and replace with
									UpdateVDDestination.
		 <3>	 2/24/91	CK		Add CalculateScale prototype.
		 <2>	 2/13/91	CK		Change to Warhol matrix stuff, Add SetIdentity

	To Do:
*/

/* Digitizer Utilities DIGIUtils.h */

/* 
	File name: 	DIGIUtils.h 
	Function:	Header file for some useful digitizer Utilities
	History:	1/30/91	New today
				
	To do:
		
*/


#ifndef _DIGIUtils_
#define	_DIGIUtils_

#ifndef _MoviesTypes_
	#include "Matrix.h"
#endif

#ifdef __cplusplus
extern "C"{
#endif

typedef MatrixRecord *MatrixPtr;

pascal void ValidatePixMap(PixMapHandle *pm, Rect *r, short *tx, short *ty);

pascal WindowPtr GetNewVWindow(short windowID, Ptr wStorage, WindowPtr behind);
pascal void DragVideoWindow(WindowPtr theWindow, Point startPt, Rect *dragRect);

pascal void GrowVideoWindow(WindowPtr theWindow, Point startPt);
pascal void DisposeVideoWindow(WindowPtr theWindow);
pascal void MoveVideoWindow(WindowPtr theWindow, short h, short v, Boolean front);
pascal long	UpdateVDDestination( WindowPtr theWindow );
void RectLocalToGlobal(Rect *r);
void RectGlobalToLocal(Rect *r);

#ifdef __cplusplus
}
#endif

#endif	_DIGIUtils_
